{$S-,R-,V-,I-,B-,F+,O+,A-,X+,N-}

program BillOfM;

{*****************************************************************************
*                                                                            *
*                      PROGRAM TO EXTRACT BILL OF MATERIALS                  *
*                                                                            *
* This is a skeleton of how to do costing of a TurboCAD drawing using Turbo  *
* Pascal.  For this example, a name and cost is associated with each symbol  *
* in the BILLOFM.TCD example drawing by using the Tools|Grouping|Set Info    *
* command.                                                                   *
*                                                                            *
* This program uses the first 20 characters of the info field for the Name   *
* and the next 10 characters for COST, e.g. "Bathtub            175.00"      *
*                                                                            *
* This program reads the Interface file created by marking all entities and  *
* using the Utility|Write Marked|Interface command.                          *
*                                                                            *
******************************************************************************}

uses
  Crt,
  Dos;

var
  F     : Text;
  S     : String;
  Code  : Integer;
  Cost  : Real;
  Total : Real;

begin
  ClrScr;
  Assign(F, 'BILLOFM.INT');
  Reset(F);
  if IOResult <> 0 then begin
    Writeln('BILLOFM.INT not found');
    Halt(1);
  end;
  Total := 0.0;
  Writeln('TurboCAD Bill of Materials Example Program');
  Writeln;
  Writeln('Item                      Cost');
  Writeln('--------------------  --------');
  while not Eof(F) do begin

    {read a line of the interface file}
    Readln(F, S);

    {we put our data in the info field of group entities}
    if (S = 'GROUP') then begin

      {skip entity id number and group link}
      Readln(F, S);
      Readln(F, S);

      {now read the info field - it should be then Name/value info}
      Readln(F, S);

      if S <> '' then begin
        Writeln(S);
        S := Copy(S, 21, 10);
        Val(S, Cost, Code);

        {if we converted the info, add to total}
        if Code = 0 then
          Total := Total + Cost;
      end;

    end;
  end;
  Close(F);
  Writeln('                      --------');
  Writeln('Total Materials Cost: ',Total:8:2);
end.

